#!/usr/bin/perl
	
#to run, use "perl driver.pl k" 
$print_ver = 1;

#read k	
$k = $ARGV[0];
print STDERR "The size (k) of the board is: $k\n";

#initial an empty k*k board
open(INI, ">ini_board.txt") || die "Can't open the file: ini_board.txt $! \n";
for($i=0;$i<$k;$i++){
	for($j=0;$j<$k;$j++){
		print INI '_';		
	}
}
print INI "\n";
close(INI);

system("cp ini_board.txt board.txt");
	
$result = 5;
&print_board();
$step =0 ;
#while ($result == 5 and $step <2)
while ($result == 5 )
{		
	
	$move = `echo $k|./playerA`;
	chop($move);
	$row = int ( $move / $k);$col = $move % $k;	
	
	$step++;
	print STDERR "Step$step: A made move, $move (row = $row, col = $col)\n";		
	$result = `./move $k $move 0`;
	chop($result);
	&print_board();
		
	
	if($result == 0) {die "Player A(wiht \'X\') won\n";}
	elsif($result == 2) {die "Draw\n";}
	elsif($result == 3) {die "Player B(wiht \'O\') won, beause A's move is invalid\n";}
	
	
	$move = `echo $k|./playerB`;
	chop($move);
	$row = int ( $move / $k);$col = $move % $k;	
	
	$step++;
	print STDERR "Step$step: B made move, $move (row = $row, col = $col)\n";
	$result = `./move $k $move 1`;
	chop($result);
	&print_board();
	
	
	if($result == 1) {die "Player B(wiht \'O\') won\n";}
	elsif($result == 2) {die "Draw\n";}
	elsif($result == 3) {die "Player A(wiht \'X\') won, beause B's move is invalid\n";}
	
}

sub print_board()
{	
	open(BOARD, "board.txt") || die "Can't open the file: board.txt $! \n";
	$linetext = <BOARD>;
	
	@board = split(//,$linetext);
	for($row=0;$row<$k;$row++){	
		if($print_ver) { print STDERR "$row  ";}
		for($col=0;$col<$k;$col++){
			print STDERR "$board[$row*$k+$col] ";
		}		
		print STDERR "\n";
	}			
	
	if($print_ver){
		print STDERR "   ";
		for($col=0;$col<$k;$col++){
			
			print STDERR "$col ";
		}
		print STDERR "\n";
	}
	
	close(BOARD);
}
